Index: trunk/src/VBox/Disassembler/testcase/tstDisasm-1.cpp
===================================================================
--- trunk/src/VBox/Disassembler/testcase/tstDisasm-1.cpp	(revision 99775)
+++ trunk/src/VBox/Disassembler/testcase/tstDisasm-1.cpp	(revision 101539)
@@ -89,5 +89,5 @@
         DISSTATE        DisOnly;
         rc = DISInstrWithPrefetchedBytes((uintptr_t)&pabInstrs[off], enmDisCpuMode,  0 /*fFilter - none */,
-                                         Dis.u.abInstr, Dis.cbCachedInstr, NULL, NULL, &DisOnly, &cbOnly);
+                                         Dis.Instr.ab, Dis.cbCachedInstr, NULL, NULL, &DisOnly, &cbOnly);
 
         RTTESTI_CHECK_RC(rc, VINF_SUCCESS);
@@ -109,5 +109,5 @@
 {
     RT_NOREF1(cbMinRead);
-    memcpy(&pDis->u.abInstr[offInstr], (void *)((uintptr_t)pDis->uInstrAddr + offInstr), cbMaxRead);
+    memcpy(&pDis->Instr.ab[offInstr], (void *)((uintptr_t)pDis->uInstrAddr + offInstr), cbMaxRead);
     pDis->cbCachedInstr = offInstr + cbMaxRead;
     return VINF_SUCCESS;
Index: trunk/src/VBox/Disassembler/testcase/tstDisasm-2.cpp
===================================================================
--- trunk/src/VBox/Disassembler/testcase/tstDisasm-2.cpp	(revision 99775)
+++ trunk/src/VBox/Disassembler/testcase/tstDisasm-2.cpp	(revision 101539)
@@ -149,5 +149,5 @@
         case OP_MOV_DR:
         case OP_MOV_TR:
-            if (pDis->arch.x86.ModRM.Bits.Mod != 3)
+            if (pDis->x86.ModRM.Bits.Mod != 3)
                 return false;
             break;
@@ -155,6 +155,6 @@
          /* The 0x8f /0 variant of this instruction doesn't get its /r value verified. */
         case OP_POP:
-            if (    pDis->arch.x86.bOpCode == 0x8f
-                &&  pDis->arch.x86.ModRM.Bits.Reg != 0)
+            if (    pDis->x86.bOpCode == 0x8f
+                &&  pDis->x86.ModRM.Bits.Reg != 0)
                 return false;
             break;
@@ -162,7 +162,7 @@
         /* The 0xc6 /0 and 0xc7 /0 variants of this instruction don't get their /r values verified. */
         case OP_MOV:
-            if (    (   pDis->arch.x86.bOpCode == 0xc6
-                     || pDis->arch.x86.bOpCode == 0xc7)
-                &&  pDis->arch.x86.ModRM.Bits.Reg != 0)
+            if (    (   pDis->x86.bOpCode == 0xc6
+                     || pDis->x86.bOpCode == 0xc7)
+                &&  pDis->x86.ModRM.Bits.Reg != 0)
                 return false;
             break;
@@ -192,5 +192,5 @@
         //size_t cbToRead    = cbMaxRead;
         size_t cbToRead    = cbMinRead;
-        memcpy(&pState->Dis.u.abInstr[offInstr], pState->pbNext, cbToRead);
+        memcpy(&pState->Dis.Instr.ab[offInstr], pState->pbNext, cbToRead);
         pState->Dis.cbCachedInstr = offInstr + (uint8_t)cbToRead;
         pState->pbNext    += cbToRead;
@@ -207,5 +207,5 @@
         if (pState->cbLeft > 0)
         {
-            memcpy(&pState->Dis.u.abInstr[offInstr], pState->pbNext, pState->cbLeft);
+            memcpy(&pState->Dis.Instr.ab[offInstr], pState->pbNext, pState->cbLeft);
             offInstr          += (uint8_t)pState->cbLeft;
             cbMinRead         -= (uint8_t)pState->cbLeft;
@@ -214,5 +214,5 @@
             pState->cbLeft     = 0;
         }
-        memset(&pState->Dis.u.abInstr[offInstr], 0xcc, cbMinRead);
+        memset(&pState->Dis.Instr.ab[offInstr], 0xcc, cbMinRead);
         pState->rc = VERR_EOF;
     }
@@ -223,5 +223,5 @@
          */
         RTStrmPrintf(g_pStdErr, "Reading before current instruction!\n");
-        memset(&pState->Dis.u.abInstr[offInstr], 0x90, cbMinRead);
+        memset(&pState->Dis.Instr.ab[offInstr], 0x90, cbMinRead);
         pState->rc = VERR_INTERNAL_ERROR;
     }
@@ -316,5 +316,5 @@
                 if (!State.cbInstr)
                 {
-                    State.Dis.u.abInstr[0] = 0;
+                    State.Dis.Instr.ab[0] = 0;
                     State.Dis.pfnReadBytes(&State.Dis, 0, 1, 1);
                     State.cbInstr = 1;
@@ -322,5 +322,5 @@
                 RTPrintf("    db");
                 for (unsigned off = 0; off < State.cbInstr; off++)
-                    RTPrintf(off ? ", %03xh" : " %03xh", State.Dis.u.abInstr[off]);
+                    RTPrintf(off ? ", %03xh" : " %03xh", State.Dis.Instr.ab[off]);
                 RTPrintf("    ; %s\n", State.szLine);
             }
@@ -345,5 +345,5 @@
                     RTPrintf("    db");
                     for (unsigned off = 0; off < State.cbInstr; off++)
-                        RTPrintf(off ? ", %03xh" : " %03xh", State.Dis.u.abInstr[off]);
+                        RTPrintf(off ? ", %03xh" : " %03xh", State.Dis.Instr.ab[off]);
                     RTPrintf(" ; ");
                 }
@@ -376,6 +376,6 @@
         {
             uint32_t cbInstrOnly = 32;
-            uint8_t  abInstr[sizeof(State.Dis.u.abInstr)];
-            memcpy(abInstr, State.Dis.u.abInstr, sizeof(State.Dis.u.abInstr));
+            uint8_t  abInstr[sizeof(State.Dis.Instr.ab)];
+            memcpy(abInstr, State.Dis.Instr.ab, sizeof(State.Dis.Instr.ab));
             int rcOnly = DISInstrWithPrefetchedBytes(State.uAddress, enmCpuMode, 0 /*fFilter - none */,
                                                      abInstr, State.Dis.cbCachedInstr, MyDisasInstrRead, &State,